//---------------------------------------------------------------------------
/** CtH[
 */
//---------------------------------------------------------------------------
/*
 * Copyright (c) 2000-2001, 2005 shimitei
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
//---------------------------------------------------------------------------
#include <vcl.h>
#include <MMSystem.h>
#include <time.h>
#include <FileCtrl.hpp> // for SelectDirectory()
#pragma hdrstop

#include "MainUnit.h"
#include "misc.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "DropEdit"
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
    ViewForm = NULL ;

    // ݌v͓KɒuĂ邽
    int tTop  = 48 ;
    int tLeft = 136 ;
    GetPluginInfoPanel->Top = tTop ;
    GetPluginInfoPanel->Left = tLeft ;
    IsSupportedPanel->Top = tTop ;
    IsSupportedPanel->Left = tLeft ;
    GetPictureInfoPanel->Top = tTop ;
    GetPictureInfoPanel->Left = tLeft ;
    GetPicturePanel->Top = tTop ;
    GetPicturePanel->Left = tLeft ;
    GetArchiveInfoPanel->Top = tTop ;
    GetArchiveInfoPanel->Left = tLeft ;
    GetFileInfoPanel->Top = tTop ;
    GetFileInfoPanel->Left = tLeft ;
    GetFilePanel->Top = tTop ;
    GetFilePanel->Left = tLeft ;
    ConfigurationDlgPanel->Top = tTop ;
    ConfigurationDlgPanel->Left = tLeft ;
}
//---------------------------------------------------------------------------
/** t@C̃hbv󂯕tݒ
 */
void __fastcall TMainForm::setDropAccept(bool flagAccept)
{
    SpipathDE->DropAccept = flagAccept ;
    IsSupportedDE->DropAccept = flagAccept ;
    GetPictureInfoDE->DropAccept = flagAccept ;
    GetPictureDE->DropAccept = flagAccept ;
    GetArchiveInfoDE->DropAccept = flagAccept ;
    GetFileInfoDE->DropAccept = flagAccept ;
    GetFileDE->DropAccept = flagAccept ;
    GetFiledestDE->DropAccept = flagAccept ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
    setDropAccept( true ) ;

    // R}hC
    int count = ::ParamCount() ;
    if ( count > 0 )
    {
        // vOC̃pXƉ
        SpipathDE->Text = ::ParamStr( 1 ) ;
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
    setDropAccept( false ) ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ReferenceButtonClick(TObject *Sender)
{
/** vOC̃pXI
 */
    if ( SpiOpenDialog->Execute() )
    {
        SpipathDE->Text = SpiOpenDialog->FileName ;
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SpipathDEDropFiles(TObject *Sender,
      char *DropFileName)
{
/** hbvꂽt@C̃t@Cݒ
 */
    TDropEdit *p = dynamic_cast<TDropEdit *>(Sender) ;
    if (p != 0)
    {
        p->Text = DropFileName ;
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::LoadButtonClick(TObject *Sender)
{
/** vOC[h
 */
    if ( ! m_spi.load( SpipathDE->Text.c_str() ) )
    {
        ::Message( "vOC̃[hɎs܂", MB_ICONEXCLAMATION ) ;
        UnloadButton->Enabled = false ;
        FunctionTV->Items->Clear() ;
        return ;
    }

    StatusBar1->SimpleText = "vOC[h܂" ;
    UnloadButton->Enabled = true ;
    SetTreeView() ;
    if (FunctionTV->Items->Count > 0)
    {
        FunctionTV->Selected = FunctionTV->Items->Item[0] ;
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UnloadButtonClick(TObject *Sender)
{
/** vOC
 */
    m_spi.unload() ;

    UnloadButton->Enabled = false ;
    FunctionTV->Items->Clear() ;

    GetPluginInfoPanel->Visible    = false ;
    IsSupportedPanel->Visible      = false ;
    GetPictureInfoPanel->Visible   = false ;
    GetPicturePanel->Visible       = false ;
    GetArchiveInfoPanel->Visible   = false ;
    GetFileInfoPanel->Visible      = false ;
    GetFilePanel->Visible          = false ;
    ConfigurationDlgPanel->Visible = false ;

    StatusBar1->SimpleText = "vOC[hĉ" ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SetTreeView(void)
{
/** vOC֐m[hǉ
 */
    FunctionTV->Items->Clear() ;

    if ( m_spi.GetPluginInfo )
    {
        FunctionTV->Items->Add( NULL, "GetPluginInfo" ) ;
    }

    if ( m_spi.IsSupported )
    {
        FunctionTV->Items->Add( NULL, "IsSupported" ) ;
    }

    if ( m_spi.GetPictureInfo )
    {
        FunctionTV->Items->Add( NULL, "GetPictureInfo" ) ;
    }

    if ( m_spi.GetPicture )
    {
        GetPictureRB->Enabled = true ;
        FunctionTV->Items->Add( NULL, "GetPicture" ) ;
    }
    else
    {
        GetPictureRB->Enabled = false ;
    }

    if ( m_spi.GetPreview )
    {
        GetPreviewRB->Enabled = true ;
        FunctionTV->Items->Add( NULL, "GetPreview" ) ;
    }
    else
    {
        GetPreviewRB->Enabled = false ;
    }

    if ( m_spi.GetArchiveInfo )
    {
        FunctionTV->Items->Add( NULL, "GetArchiveInfo" ) ;
    }

    if ( m_spi.GetFileInfo )
    {
        FunctionTV->Items->Add( NULL, "GetFileInfo" ) ;
    }

    if ( m_spi.GetFile )
    {
        FunctionTV->Items->Add( NULL, "GetFile" ) ;
    }
    
    if ( m_spi.ConfigurationDlg )
    {
        FunctionTV->Items->Add( NULL, "ConfigurationDlg" ) ;
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FunctionTVChange(TObject *Sender, TTreeNode *Node)
{
    GetPluginInfoPanel->Visible = false ;
    IsSupportedPanel->Visible = false ;
    GetPictureInfoPanel->Visible = false ;
    GetPicturePanel->Visible = false ;
    GetArchiveInfoPanel->Visible = false ;
    GetFileInfoPanel->Visible = false ;
    GetFilePanel->Visible = false ;
    ConfigurationDlgPanel->Visible = false ;

    AnsiString func = Node->Text ;
    if ( func == "GetPluginInfo" )
    {
        GetPluginInfoPanel->Visible = true ;
        StatusBar1->SimpleText = "Plug-inɊւ𓾂" ;
    }
    else if ( func == "IsSupported" )
    {
        IsSupportedPanel->Visible = true ;
        StatusBar1->SimpleText = "Ή`ׂ" ;
    }
    else if ( func == "GetPictureInfo" )
    {
        GetPictureInfoPanel->Visible = true ;
        StatusBar1->SimpleText = "摜t@CɊւ𓾂" ;
    }
    else if ( func == "GetPicture" )
    {
        GetPicturePanel->Visible = true ;
        GetPictureRB->Checked = true ;
        StatusBar1->SimpleText = "摜WJ" ;
    }
    else if ( func == "GetPreview" )
    {
        GetPicturePanel->Visible = true ;
        GetPreviewRB->Checked = true ;
        StatusBar1->SimpleText = "vr[p摜WJ" ;
    }
    else if ( func == "GetArchiveInfo" )
    {
        GetArchiveInfoPanel->Visible = true ;
        StatusBar1->SimpleText = "A[JCûׂẴt@C̏擾" ;
    }
    else if ( func == "GetFileInfo" )
    {
        GetFileInfoPanel->Visible = true ;
        StatusBar1->SimpleText = " A[JCu̎w肵t@C̏擾" ;
    }
    else if ( func == "GetFile" )
    {
        GetFilePanel->Visible = true ;
        StatusBar1->SimpleText = "A[JCũt@C擾" ;
    }
    else if ( func == "ConfigurationDlg" )
    {
        ConfigurationDlgPanel->Visible = true ;
        StatusBar1->SimpleText = "Plug-inݒ_CAO\" ;
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::GetPluginInfoButtonClick(TObject *Sender)
{
    // `FbN
    int infono ;
    unsigned char buf[513] ;
    int buflen ;
    bool err = false ;
    int ret ;

    // lsłȂ`FbN
    if ( infonoEdit->Text.IsEmpty() )
    {
        err = true ;
    }
    else
    {
        try
        {
            infono = infonoEdit->Text.ToInt() ;
        }
        catch (...)
        {
            infonoEdit->Text = "0" ;
            err = true ;
        }
    }

    if ( buflenEdit->Text.IsEmpty() )
    {
        err = true;
    }
    else
    {
        try
        {
            buflen = buflenEdit->Text.ToInt() ;
        }
        catch (...)
        {
            buflenEdit->Text = "64" ;
            err = true ;
        }
    }

    if ( err )
    {
        ::Message( "sȒl܂I", MB_ICONEXCLAMATION ) ;
        return ;
    }

    // buf
    memset( buf, 0x01, 512 ) ;
    buf[512] = '\0' ;

    if ( buflen > 512 )
    {
        buflenEdit->Text = "512" ;
        buflen = 512 ;
    }

    // ֐s
    ret = m_spi.GetPluginInfo( infono, buf, buflen ) ;

    // ʂ\
    GetPluginInfoLabel->Caption = ret ;
    AnsiString buftxt ;
    bool addnull = false ;
    for (int i=0; i < 512; i++)
    {
        if ( buf[i] < 2 )
        {
            if ( buf[i] == '\0' )
            {
                addnull = true ;
            }
            else
            {
                buf[i] = '\0' ;
            }
            break ;
        }
    }
    buftxt = (char *)buf ;
    if ( addnull ) buftxt += "\\0" ;

    GetPluginInfoRE->Lines->Text = buftxt ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::reButtonClick(TObject *Sender)
{
    if ( coOpenDialog->Execute() )
    {
        // pXEditBox
        IsSupportedDE->Text    = coOpenDialog->FileName;
        GetPictureInfoDE->Text = coOpenDialog->FileName;
        GetPictureDE->Text     = coOpenDialog->FileName;
        GetArchiveInfoDE->Text = coOpenDialog->FileName;
        GetFileInfoDE->Text    = coOpenDialog->FileName;
        GetFileDE->Text        = coOpenDialog->FileName;
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::IsSupportedButtonClick(TObject *Sender)
{
    // lsłȂ`FbN
    bool err = false ;
    int ofset ;
    if ( IsSupportedEdit->Text.IsEmpty() )
    {
        err = true ;
    }
    else
    {
        try
        {
            ofset = IsSupportedEdit->Text.ToInt() ;
            if ( ofset < 0 )
            {
                // ̒l͂͂
                IsSupportedEdit->Text = "0" ;
                err = true ;
            }
        }
        catch (...)
        {
            IsSupportedEdit->Text = "0" ;
            err = true ;
        }
    }
    
    if ( err )
    {
        ::Message( "sȒl܂I", MB_ICONEXCLAMATION ) ;
        return ;
    }

    // ֐s
    int ret ;
    HANDLE dw ;

    dw = ::CreateFile( IsSupportedDE->Text.c_str(), GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL ) ;
    if ( dw == INVALID_HANDLE_VALUE )
    {
        ::Message("t@CJ܂I", MB_ICONEXCLAMATION) ;
        return ;
    }
    // ItZbgV[N
    ::SetFilePointer( dw, ofset, NULL, FILE_BEGIN ) ;
    if ( IsSupportedRG->ItemIndex == 0 )
    {
        // t@Cnh
        ret = m_spi.IsSupported( IsSupportedDE->Text.c_str(), (DWORD)dw ) ;
    }
    else
    {
        DWORD ReadBytes ;
        char buf[4000] ;
        ::memset( buf, 0, 4000 ) ;
        if ( ! ::ReadFile( dw, buf, 4000, &ReadBytes, NULL ) )
        {
            ::CloseHandle( dw ) ;
            ::Message( "t@Cǂݎ܂I", MB_ICONEXCLAMATION ) ;
            return ;
        }
        ret = m_spi.IsSupported( IsSupportedDE->Text.c_str(), reinterpret_cast<DWORD>(buf) ) ;
    }
    ::CloseHandle( dw ) ;

    // ʂ\
    IsSupportedLabel->Caption = ret ;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMainForm::flag2bitstr(AnsiString &flagstr)
{
    // lsłȂ`FbN
    bool err = false ;
    int flag ;
    if ( flagstr.IsEmpty() )
    {
        err = true ;
    }
    else
    {
        try
        {
            flag = flagstr.ToInt() ;
        }
        catch (...)
        {
            flagstr = "0x0000" ;
            err = true ;
        }
    }

    if ( err )
    {
        ::Message( "sȒlłI", MB_ICONEXCLAMATION ) ;
        return (AnsiString)"xxxx xxxx  xxxx xxxx  " ;
    }

    return short2bitstr( flag ) ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::GetPictureInfoflagButtonClick(TObject *Sender)
{
    AnsiString str = GetPictureInfoflagEdit->Text ;
    bitflagLabel->Caption = flag2bitstr( str ) ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::IsSupportedDEDropFiles(TObject *Sender,
      char *DropFileName)
{
    // t@CEditBoxɒǉ
    IsSupportedDE->Text    = DropFileName ;
    GetPictureInfoDE->Text = DropFileName ;
    GetPictureDE->Text     = DropFileName ;
    GetArchiveInfoDE->Text = DropFileName ;
    GetFileInfoDE->Text    = DropFileName ;
    GetFileDE->Text        = DropFileName ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::GetPictureInfoButtonClick(TObject *Sender)
{
    // lsłȂ`FbN
    bool err = false ;
    int ofset ;
    if ( GetPictureInfoEdit->Text.IsEmpty() )
    {
        err = true ;
    }
    else
    {
        try
        {
            ofset = GetPictureInfoEdit->Text.ToInt() ;
            if (ofset < 0)
            {
                GetPictureInfoEdit->Text = "0" ;
                err = true ;
            }
        }
        catch (...)
        {
            GetPictureInfoEdit->Text = "0" ;
            err = true ;
        }
    }

    int flag ;
    if ( GetPictureInfoflagEdit->Text.IsEmpty() )
    {
        err = true ;
    }
    else
    {
        try
        {
            flag = GetPictureInfoflagEdit->Text.ToInt() ;
        }
        catch (...)
        {
            GetPictureInfoflagEdit->Text = "0" ;
            err = true ;
        }
    }

    if ( err )
    {
        ::Message("sȒl܂I", MB_ICONEXCLAMATION ) ;
        return ;
    }

    // ֐s
    int ret ;
    PictureInfo picinfo ;
    if ( GetPictureInfoCB->Checked )
    {
        ::memset( &picinfo, 0, sizeof(picinfo) ) ;
    }
    else
    {
        ::memset( &picinfo, 0xcc, sizeof(picinfo) ) ;
    }

    if ( (flag & 7) == 0 )
    {
        // fBXNt@C
        ret = m_spi.GetPictureInfo( GetPictureInfoDE->Text.c_str(), ofset, flag, &picinfo ) ;
    }
    else
    {
        // ̃C[W
        HANDLE hf ;
        DWORD ReadBytes ;
        DWORD fsize ;
        hf = ::CreateFile( GetPictureInfoDE->Text.c_str(), GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL ) ;
        if ( hf == INVALID_HANDLE_VALUE )
        {
            ::Message( "t@CJ܂I", MB_ICONEXCLAMATION ) ;
            return ;
        }
        fsize = ::GetFileSize( hf, NULL ) - ofset ;
        ::SetFilePointer( hf, ofset, NULL, FILE_BEGIN ) ;
        char *buf = (char *)::LocalAlloc( LMEM_FIXED, fsize ) ;
        if ( buf == NULL )
        {
            ::CloseHandle(hf);
            ::Message( "mۂł܂I", MB_ICONEXCLAMATION ) ;
            return ;
        }
        if ( ! ::ReadFile( hf, buf, fsize, &ReadBytes, NULL ) )
        {
            ::CloseHandle( hf ) ;
            ::LocalFree( buf ) ;
            ::Message( "t@Cǂݎ܂I", MB_ICONEXCLAMATION ) ;
            return ;
        }
        ret = m_spi.GetPictureInfo( buf, fsize, flag, &picinfo ) ;
        ::LocalFree( buf ) ;
        ::CloseHandle( hf ) ;
    }

    // ʂ\
    GetPictureInfoLabel->Caption = ret ;
    AnsiString text = "" ;
    text += "left = " + (AnsiString)picinfo.left + "\n" ;
    text += "top  = " + (AnsiString)picinfo.top +"\n";
    text += "width  = " + (AnsiString)picinfo.width + "\n" ;
    text += "height = " + (AnsiString)picinfo.height + "\n" ;
    text += "x_density = " + (AnsiString)picinfo.x_density + "\n" ;
    text += "y_density = " + (AnsiString)picinfo.y_density + "\n" ;
    text += "colorDepth = " + (AnsiString)picinfo.colorDepth + "\n" ;
    if ( picinfo.hInfo != NULL )
    {
        if ( 0xcccccccc == reinterpret_cast<unsigned long>(picinfo.hInfo) )
        {
            text += "hInfo = 0xcccccccc\n" ;
        }
        else
        {
            char *come = static_cast<char *>(::LocalLock( picinfo.hInfo )) ;
            text += (AnsiString)"hInfo = \"" + (AnsiString)come + "\"\n" ;
            ::LocalUnlock( picinfo.hInfo ) ;
        }
    }
    else
    {
        text += "hInfo = NULL\n" ;
    }

    GetPictureInfoRE->Lines->Text = text ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::GetPictureflagButtonClick(TObject *Sender)
{
    AnsiString str = GetPictureflagEdit->Text ;
    GetPictureflagLabel->Caption = flag2bitstr( str ) ;
}
//---------------------------------------------------------------------------
static int __stdcall GetPictureCallback(int nNum, int nDenom, long lData)
{
    TMainForm *tForm = reinterpret_cast<TMainForm *>(lData) ;
    if ( (tForm = dynamic_cast<TMainForm *>(tForm)) != 0 )
    {
        tForm->GetPictureProgressBar->Max = nDenom ;
        tForm->GetPictureProgressBar->Position = nNum ;
        tForm->GetPictureRE->Lines->Add((AnsiString)"") ;
        tForm->GetPictureRE->Lines->Add((AnsiString)"nNum = " +nNum) ;
        tForm->GetPictureRE->Lines->Add((AnsiString)"nDenom = " +nDenom) ;

        Application->ProcessMessages() ;
        if ( tForm->GetPictureButton->Tag == 2 ) return 1 ;
    }
    return 0 ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::GetPictureButtonClick(TObject *Sender)
{
    if ( GetPictureButton->Tag > 0 )
    {
        GetPictureButton->Caption = "~" ;
        GetPictureButton->Tag = 2 ;
        return ;
    }
    GetPictureButton->Caption = "LZ" ;
    GetPictureButton->Tag = 1 ;

    // lsłȂ`FbN
    bool err = false ;
    int ofset ;
    if ( GetPictureEdit->Text.IsEmpty() )
    {
        err = true ;
    }
    else
    {
        try
        {
            ofset = GetPictureEdit->Text.ToInt() ;
            if ( ofset < 0 )
            {
                GetPictureEdit->Text = "0" ;
                err = true ;
            }
        }
        catch (...)
        {
            GetPictureEdit->Text = "0" ;
            err = true ;
        }
    }

    int flag ;
    if ( GetPictureflagEdit->Text.IsEmpty() )
    {
        err = true ;
    }
    else
    {
        try
        {
            flag = GetPictureflagEdit->Text.ToInt() ;
        }
        catch (...)
        {
            GetPictureflagEdit->Text = "0" ;
            err = true ;
        }
    }

    if ( err )
    {
        ::Message( "sȒl܂I", MB_ICONEXCLAMATION ) ;
        GetPictureButton->Caption = "s" ;
        GetPictureButton->Tag = 0 ;
        return ;
    }

    // ֐s
    SPI_PROGRESS callback = NULL;
    if ( GetPictureCB->Checked )
    {
        // R[obN֐n
        callback = GetPictureCallback ;
    }

    GetPictureRE->Clear() ;

    HANDLE HBInfo ;
    HANDLE HBm ;
    int ret ;
    if ( (flag & 7) == 0 )
    {
        // fBXNt@C
        if ( GetPictureRB->Checked )
        {
            ret = m_spi.GetPicture( GetPictureDE->Text.c_str(), ofset, flag, &HBInfo, &HBm, callback, (long)this ) ;
        }
        else
        {
            ret = m_spi.GetPreview( GetPictureDE->Text.c_str(), ofset, flag, &HBInfo, &HBm, callback, (long)this ) ;
        }
    }
    else
    {
        // ̃C[W
        HANDLE hf ;
        DWORD ReadBytes ;
        DWORD fsize ;
        hf = CreateFile( GetPictureDE->Text.c_str(), GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL ) ;
        if ( hf == INVALID_HANDLE_VALUE )
        {
            ::Message( "t@CJ܂I", MB_ICONEXCLAMATION ) ;
            GetPictureButton->Caption = "s" ;
            GetPictureButton->Tag = 0 ;
            return ;
        }
        fsize = ::GetFileSize(hf, NULL) - ofset ;
        ::SetFilePointer( hf, ofset, NULL, FILE_BEGIN ) ;
        char *buf = static_cast<char *>(::LocalAlloc( LMEM_FIXED, fsize )) ;
        if ( buf == NULL )
        {
            ::CloseHandle( hf ) ;
            ::Message( "mۂł܂I", MB_ICONEXCLAMATION ) ;
            GetPictureButton->Caption = "s" ;
            GetPictureButton->Tag = 0 ;
            return ;
        }
        if ( ! ::ReadFile( hf, buf, fsize, &ReadBytes, NULL ) )
        {
            ::CloseHandle( hf ) ;
            ::LocalFree( buf ) ;
            ::Message( "t@Cǂݎ܂I", MB_ICONEXCLAMATION ) ;
            GetPictureButton->Caption = "s" ;
            GetPictureButton->Tag = 0 ;
            return ;
        }
        if ( GetPictureRB->Checked )
        {
            ret = m_spi.GetPicture( buf, fsize, flag, &HBInfo, &HBm, callback, reinterpret_cast<long>(this) ) ;
        }
        else
        {
            ret = m_spi.GetPreview( buf, fsize, flag, &HBInfo, &HBm, callback, reinterpret_cast<long>(this) ) ;
        }
        ::LocalFree( buf ) ;
        ::CloseHandle( hf ) ;
    }

    // ʂ\
    GetPictureLabel->Caption = ret ;

    // \
    if ( ret == 0 )
    {
        HLOCAL hfile = NULL ;
        if ( ViewForm == NULL )
        {
            ViewForm = new TViewForm(this) ;
        }
        ViewForm->Visible = false ;
        ViewForm->setdata( &HBInfo, &HBm, &hfile ) ;
        ViewForm->viewchange( modePictureView ) ;
        ViewForm->Visible = true ;
    }

    GetPictureButton->Caption = "s" ;
    GetPictureButton->Tag = 0 ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ConfigurationDlgButtonClick(TObject *Sender)
{
    // `FbN
    int fnc ;
    bool err = false ;
    int ret ;

    // lsłȂ`FbN
    if ( ConfigurationDlgEdit->Text.IsEmpty() )
    {
        err = true ;
    }
    else
    {
        try
        {
            fnc = ConfigurationDlgEdit->Text.ToInt() ;
        }
        catch (...)
        {
            ConfigurationDlgEdit->Text = "0" ;
            err = true ;
        }
    }

    if ( err )
    {
        ::Message( "sȒl܂I", MB_ICONEXCLAMATION ) ;
        return ;
    }

    // ֐s
    ret = m_spi.ConfigurationDlg( Handle, fnc ) ;

    // ʂ\
    ConfigurationDlgLabel->Caption = ret ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::GetArchiveInfoflagButtonClick(TObject *Sender)
{
    AnsiString str = GetArchiveInfoflagEdit->Text ;
    GetArchiveInfoflagLabel->Caption = flag2bitstr( str ) ;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMainForm::fileInfo2str(fileInfo *pinfo)
{
    AnsiString infostr = "" ;

    char tmp[201] ;
    AnsiString strmethod ;
    AnsiString strtime ;
    AnsiString strpath ;
    AnsiString strfilename ;

    bool addnull = false ;
    tmp[8] = '\0' ;
    ::memcpy( tmp, pinfo->method, 8 ) ;
    for (int i=0; i < 8; i++)
    {
        if ( pinfo->method[i] == '\0' )
        {
            addnull = true ;
            break ;
        }
    }
    strmethod = tmp ;
    if ( addnull ) strmethod += "\\0" ;
    //"Mon Nov 21 11:31:54 1983\n\0"݂Ȋ
    strtime = ::ctime( &pinfo->timestamp ) ;
    tmp[200] = '\0' ;
    ::memset( tmp, 0, 200 ) ;
    ::memcpy( tmp, pinfo->path, 200 ) ;
    addnull = false ;
    for (int i=0; i < 200; i++)
    {
        if ( pinfo->path[i] == '\0' )
        {
            addnull = true ;
            break ;
        }
    }
    strpath = tmp ;
    if ( addnull ) strpath += "\\0" ;
    tmp[200] = '\0' ;
    ::memset( tmp, 0, 200 ) ;
    ::memcpy( tmp, pinfo->filename, 200 ) ;
    addnull = false ;
    for (int i=0; i < 200; i++)
    {
        if ( pinfo->filename[i] == '\0' )
        {
            addnull = true ;
            break ;
        }
    }
    strfilename = tmp ;
    if ( addnull ) strfilename += "\\0" ;

    infostr += "method    = \"" + strmethod + "\"\n" ;
    infostr += "position  = " + (AnsiString)pinfo->position + "\n" ;
    infostr += "compsize  = " + (AnsiString)pinfo->compsize + "\n" ;
    infostr += "filesize  = " + (AnsiString)pinfo->filesize + "\n" ;
    infostr += "timestamp = " + strtime ;
    infostr += "path      = \"" + strpath + "\"\n" ;
    infostr += "filename  = \"" + strfilename + "\"\n" ;
    infostr += "crc       = " + (AnsiString)pinfo->crc + "\n" ;
    infostr += "\n\n" ;

    return infostr ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::GetArchiveInfoButtonClick(TObject *Sender)
{
    // lsłȂ`FbN
    bool err = false ;
    int ofset ;
    if ( GetArchiveInfoEdit->Text.IsEmpty() )
    {
        err = true ;
    }
    else
    {
        try
        {
            ofset = GetArchiveInfoEdit->Text.ToInt() ;
            if ( ofset < 0 )
            {
                GetArchiveInfoEdit->Text = "0" ;
                err = true ;
            }
        }
        catch (...)
        {
            GetArchiveInfoEdit->Text = "0" ;
            err = true ;
        }
    }

    int flag ;
    if ( GetArchiveInfoflagEdit->Text.IsEmpty() )
    {
        err = true ;
    }
    else
    {
        try
        {
            flag = GetArchiveInfoflagEdit->Text.ToInt() ;
        }
        catch (...)
        {
            GetArchiveInfoflagEdit->Text = "0" ;
            err = true ;
        }
    }

    if ( err )
    {
        ::Message( "sȒl܂I", MB_ICONEXCLAMATION ) ;
        return ;
    }

    // ֐s
    int ret ;
    HLOCAL hfinfo = NULL ;

    if ( (flag & 7) == 0 )
    {
        // fBXNt@C
        ret = m_spi.GetArchiveInfo( GetArchiveInfoDE->Text.c_str(), ofset, flag, &hfinfo ) ;
    }
    else
    {
        // ̃C[W
        HANDLE hf ;
        DWORD ReadBytes ;
        DWORD fsize ;
        hf = ::CreateFile( GetArchiveInfoDE->Text.c_str(), GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL ) ;
        if ( hf == INVALID_HANDLE_VALUE )
        {
            ::Message( "t@CJ܂I", MB_ICONEXCLAMATION ) ;
            return ;
        }
        fsize = ::GetFileSize( hf, NULL ) - ofset ;
        ::SetFilePointer( hf, ofset, NULL, FILE_BEGIN ) ;
        char *buf = static_cast<char *>(::LocalAlloc( LMEM_FIXED, fsize )) ;
        if ( buf == NULL )
        {
            ::CloseHandle( hf ) ;
            ::Message( "mۂł܂I", MB_ICONEXCLAMATION ) ;
            return ;
        }
        if ( ! ::ReadFile( hf, buf, fsize, &ReadBytes, NULL ) )
        {
            ::CloseHandle( hf ) ;
            ::LocalFree( buf ) ;
            ::Message( "t@Cǂݎ܂I", MB_ICONEXCLAMATION ) ;
            return ;
        }
        ret = m_spi.GetArchiveInfo( buf, fsize, flag, &hfinfo ) ;
        ::LocalFree( buf ) ;
        ::CloseHandle( hf ) ;
    }

    // ʂ\
    GetArchiveInfoLabel->Caption = ret ;
    if ( hfinfo != NULL )
    {
        fileInfo *pfinfo ;
        pfinfo = static_cast<fileInfo *>(::LocalLock( hfinfo ) ) ;
        AnsiString text = "" ;
        GetFileInfoComboBox->Clear() ;
        for (;;)
        {
            if ( pfinfo->method[0] == '\0' ) break ;
            text += fileInfo2str( pfinfo ) ;
            // GetFileInfõR{{bNXɓƂ
            GetFileInfoComboBox->Items->Add( pfinfo->path +(AnsiString)pfinfo->filename ) ;
            pfinfo++ ;
        }

        GetArchiveInfoRE->Lines->Text = text ;

        ::LocalUnlock( hfinfo ) ;
        ::LocalFree( hfinfo ) ;
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::GetFileInfoflagButtonClick(TObject *Sender)
{
    AnsiString str = GetFileInfoflagEdit->Text ;
    GetFileInfoflagLabel->Caption = flag2bitstr( str ) ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::GetFileInfoButtonClick(TObject *Sender)
{
    // lsłȂ`FbN
    bool err = false ;
    int ofset ;
    if ( GetFileInfoEdit->Text.IsEmpty() )
    {
        err = true ;
    }
    else
    {
        try
        {
            ofset = GetFileInfoEdit->Text.ToInt() ;
            if ( ofset < 0 )
            {
                GetFileInfoEdit->Text = "0" ;
                err = true ;
            }
        }
        catch (...)
        {
            GetFileInfoEdit->Text = "0" ;
            err = true ;
        }
    }

    int flag ;
    if ( GetFileInfoflagEdit->Text.IsEmpty() )
    {
        err = true ;
    }
    else
    {
        try
        {
            flag = GetFileInfoflagEdit->Text.ToInt() ;
        }
        catch (...)
        {
            GetFileInfoflagEdit->Text = "0" ;
            err = true ;
        }
    }

    if ( err )
    {
        ::Message( "sȒl܂I", MB_ICONEXCLAMATION ) ;
        return ;
    }

    // ֐s
    int ret ;
    fileInfo finfo ;
    if ( GetFileInfoCheckBox->Checked )
    {
        ::memset( &finfo, 0, sizeof(finfo) ) ;
    }
    else
    {
        ::memset( &finfo, 0xcc, sizeof(finfo) ) ;
    }

    if ( (flag & 7) == 0 )
    {
        // fBXNt@C
        ret = m_spi.GetFileInfo( GetFileInfoDE->Text.c_str(), ofset, GetFileInfoComboBox->Text.c_str(), flag, &finfo ) ;
    }
    else
    {
        // ̃C[W
        HANDLE hf ;
        DWORD ReadBytes ;
        DWORD fsize ;
        hf = ::CreateFile( GetFileInfoDE->Text.c_str(), GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL ) ;
        if ( hf == INVALID_HANDLE_VALUE )
        {
            ::Message( "t@CJ܂I", MB_ICONEXCLAMATION ) ;
            return ;
        }
        fsize = ::GetFileSize( hf, NULL ) - ofset ;
        ::SetFilePointer( hf, ofset, NULL, FILE_BEGIN ) ;
        char *buf = static_cast<char *>(::LocalAlloc( LMEM_FIXED, fsize )) ;
        if ( buf == NULL )
        {
            ::CloseHandle( hf ) ;
            ::Message( "mۂł܂I", MB_ICONEXCLAMATION ) ;
            return ;
        }
        if ( ! ::ReadFile( hf, buf, fsize, &ReadBytes, NULL ) )
        {
            ::CloseHandle( hf ) ;
            ::LocalFree( buf ) ;
            ::Message( "t@Cǂݎ܂I", MB_ICONEXCLAMATION ) ;
            return ;
        }
        ret = m_spi.GetFileInfo( buf, fsize, GetFileInfoComboBox->Text.c_str(), flag, &finfo ) ;
        ::LocalFree( buf ) ;
        ::CloseHandle( hf ) ;
    }

    // ʂ\
    GetFileInfoLabel->Caption = ret ;
    GetFileInfoRE->Lines->Text = fileInfo2str( &finfo ) ;

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::GetFileflagButtonClick(TObject *Sender)
{
    AnsiString str = GetFileflagEdit->Text ;
    GetFileflagLabel->Caption = flag2bitstr( str ) ;
}
//---------------------------------------------------------------------------
static int __stdcall GetFileCallback(int nNum, int nDenom, long lData)
{
    TMainForm *tForm = reinterpret_cast<TMainForm *>(lData) ;
    if ( (tForm = dynamic_cast<TMainForm *>(tForm)) != 0 )
    {
        tForm->GetFileProgressBar->Max = nDenom ;
        tForm->GetFileProgressBar->Position = nNum ;
        tForm->GetFileRE->Lines->Add( (AnsiString)"" ) ;
        tForm->GetFileRE->Lines->Add( (AnsiString)"nNum = " + nNum ) ;
        tForm->GetFileRE->Lines->Add( (AnsiString)"nDenom = " + nDenom ) ;

        Application->ProcessMessages();
        if ( tForm->GetFileButton->Tag == 2 ) return 1 ;
    }
    return 0 ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::GetFileButtonClick(TObject *Sender)
{
    if ( GetFileButton->Tag > 0 )
    {
        GetFileButton->Caption = "~" ;
        GetFileButton->Tag = 2 ;
        return ;
    }
    GetFileButton->Caption = "LZ" ;
    GetFileButton->Tag = 1 ;

    // lsłȂ`FbN
    bool err = false ;
    int ofset ;
    if ( GetFileEdit->Text.IsEmpty() )
    {
        err = true ;
    }
    else
    {
        try
        {
            ofset = GetFileEdit->Text.ToInt() ;
            if ( ofset < 0 )
            {
                GetFileEdit->Text = "0" ;
                err = true ;
            }
        }
        catch (...)
        {
            GetFileEdit->Text = "0" ;
            err = true ;
        }
    }

    int flag ;
    if ( GetFileflagEdit->Text.IsEmpty() )
    {
        err = true ;
    }
    else
    {
        try
        {
            flag = GetFileflagEdit->Text.ToInt() ;
        }
        catch (...)
        {
            GetFileflagEdit->Text = "0" ;
            err = true ;
        }
    }

    if ( err )
    {
        ::Message( "sȒl܂I", MB_ICONEXCLAMATION ) ;
        GetPictureButton->Caption = "s" ;
        GetPictureButton->Tag = 0 ;
        return ;
    }

    // ֐s
    SPI_PROGRESS callback = NULL ;
    if ( GetFileCB->Checked )
    {
        // R[obN֐n
        callback = GetFileCallback ;
    }

    GetFileRE->Clear() ;

    HANDLE hfile ;
    int ret ;
    if ( (flag & 7) == 0 )
    {
        // fBXNt@C
        if ( (flag & 0x700) == 0 )
        {
            // fBXNt@Cɏo
            ret = m_spi.GetFile( GetFileDE->Text.c_str(), ofset, GetFiledestDE->Text.c_str(), flag, callback, reinterpret_cast<long>(this) ) ;
        }
        else
        {
            // ̃C[Wɏo
            ret = m_spi.GetFile( GetFileDE->Text.c_str(), ofset, reinterpret_cast<LPSTR>(&hfile), flag, callback, reinterpret_cast<long>(this) ) ;
        }
    }
    else
    {
        // ̃C[W
        HANDLE hf ;
        DWORD ReadBytes ;
        DWORD fsize ;
        hf = ::CreateFile( GetFileDE->Text.c_str(), GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL ) ;
        if ( hf == INVALID_HANDLE_VALUE )
        {
            ::Message( "t@CJ܂I", MB_ICONEXCLAMATION ) ;
            GetPictureButton->Caption = "s" ;
            GetPictureButton->Tag = 0 ;
            return ;
        }
        fsize = ::GetFileSize( hf, NULL ) - ofset ;
        ::SetFilePointer( hf, ofset, NULL, FILE_BEGIN ) ;
        char *buf = static_cast<char *>(::LocalAlloc( LMEM_FIXED, fsize )) ;
        if ( buf == NULL )
        {
            ::CloseHandle( hf ) ;
            ::Message( "mۂł܂I", MB_ICONEXCLAMATION ) ;
            GetPictureButton->Caption = "s" ;
            GetPictureButton->Tag = 0 ;
            return ;
        }
        if ( ! ::ReadFile( hf, buf, fsize, &ReadBytes, NULL ) )
        {
            ::CloseHandle( hf ) ;
            ::LocalFree( buf ) ;
            ::Message( "t@Cǂݎ܂I", MB_ICONEXCLAMATION ) ;
            GetPictureButton->Caption = "s" ;
            GetPictureButton->Tag = 0 ;
            return ;
        }
        if ( (flag & 0x700) == 0 )
        {
            // fBXNt@Cɏo
            ret = m_spi.GetFile( buf, fsize, GetFiledestDE->Text.c_str(), flag, callback, reinterpret_cast<long>(this) ) ;
        }
        else
        {
            // ̃C[Wɏo
            ret = m_spi.GetFile( buf, fsize, reinterpret_cast<LPSTR>(&hfile), flag, callback, reinterpret_cast<long>(this) ) ;
        }
        ::LocalFree( buf ) ;
        ::CloseHandle( hf ) ;
    }

    // ʂ\
    GetFileLabel->Caption = ret ;
    // fBXNɏo͎ꉞEBhE\
    if ( ret == 0 /* && (flag & 0x700) == 0*/ )
    {
        HLOCAL HBInfo = NULL ;
        HLOCAL HBm = NULL ;
        if ( ViewForm == NULL )
        {
            ViewForm = new TViewForm(this) ;
        }
        ViewForm->Visible = false ;
        ViewForm->setdata( &HBInfo, &HBm, &hfile ) ;
        ViewForm->viewchange( modeHexView ) ;
        ViewForm->Visible = true ;
    }

    GetFileButton->Caption = "s" ;
    GetFileButton->Tag = 0 ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::GetFiledestButtonClick(TObject *Sender)
{
//GetFilẽt@Co͐ݒ
    AnsiString dirPath ;
    if ( ::SelectDirectory( "ϊtH_I", "", dirPath ) )
    {
        GetFiledestDE->Text = dirPath ;
    }
}
//---------------------------------------------------------------------------

