//---------------------------------------------------------------------------
/** C[Wr[
 */
//---------------------------------------------------------------------------
/*
 * Copyright (c) 2000-2001, 2005 shimitei
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "ViewUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//TViewForm *ViewForm;
//---------------------------------------------------------------------------
__fastcall TViewForm::TViewForm(TComponent* Owner)
        : TForm(Owner)
{
    // 
    m_hinfo = NULL ;
    m_hbm = NULL ;
    m_hfile = NULL ;
    m_mode = modePictureView ;
    m_binonly = false ;
    m_binview = false ;
    m_mousedown = false ;
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::FormCreate(TObject *Sender)
{
    // JɂꂾƂɂ̂
    Width = 614 ;
    //binPanel->Width = 605 ;
    binPanel->Align = alClient ;
    ScrollBox->Align = alClient ;
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::dataFree(void)
{
    if ( m_hinfo != NULL )
    {
        ::LocalFree( m_hinfo ) ;
        m_hinfo = NULL ;
    }
    if ( m_hbm != NULL )
    {
        ::LocalFree( m_hbm ) ;
        m_hbm = NULL;
    }
    if ( m_hfile != NULL )
    {
        ::LocalFree( m_hfile ) ;
        m_hfile = NULL ;
    }
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::FormDestroy(TObject *Sender)
{
    dataFree() ;
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::setdata(HLOCAL *phinfo, HLOCAL *phbm, HLOCAL *phfile)
{
    // Õf[^J
    m_binview = false ;
    binRE->Clear() ;
    dataFree() ;

    // f[^Zbg
    if ( (*phinfo != NULL) && (*phbm != NULL) )
    {
        m_hinfo = *phinfo ;
        m_hbm = *phbm ;

        BITMAPINFOHEADER *pbmpinfo = (BITMAPINFOHEADER *)::LocalLock( m_hinfo ) ;
        char *pbmpdata = (char *)::LocalLock( m_hbm ) ;

        // 摜̎擾
        Graphics::TBitmap *bmp ;
        bmp = new (Graphics::TBitmap) ;
        bmp->Width = pbmpinfo->biWidth ;
        bmp->Height = ::abs( pbmpinfo->biHeight ) ;
        m_gwidth = pbmpinfo->biWidth ;
        m_gheight = abs( pbmpinfo->biHeight ) ;

        if ( ::SetDIBits( bmp->Canvas->Handle, bmp->Handle, 0,
                  ::abs( pbmpinfo->biHeight ), pbmpdata,
                  (BITMAPINFO *)pbmpinfo, DIB_RGB_COLORS) != 0 )
        {
            // C[Wɕ\
            Image->Picture->Bitmap = bmp ;
        }

        // n
        delete bmp ;
        ::LocalUnlock( m_hinfo ) ;
        ::LocalUnlock( m_hbm ) ;
        m_binonly = false ;
    }

    if ( *phfile != NULL )
    {
        m_hfile = *phfile ;
        m_binonly = true ;
    }
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::viewchange(ViewMode viewmode)
{
/** \[hύX
 */

    // ^XNo[ʗ̈̑傫
    RECT rect ;
    ::SystemParametersInfo( SPI_GETWORKAREA, NULL, &rect, NULL ) ;

    switch ( viewmode )
    {
        case modePictureView:
            if ( m_binonly ) return ;
            binPanel->Visible = false ;
            Caption = "Picture View" ;
            // TCYWidth
            Width = m_gwidth +9 ;
            ScrollBox->HorzScrollBar->Visible = false ;
            if ( Width > rect.right - Left )
            {
                Width = rect.right - Left ;
                ScrollBox->HorzScrollBar->Visible = true ;
            }
            // TCYheight
            Height = m_gheight +27 ;
            ScrollBox->VertScrollBar->Visible = false ;
            if ( Height > rect.bottom - Top )
            {
                Height = rect.bottom - Top ;
                ScrollBox->VertScrollBar->Visible = true ;
            }
            ScrollBox->Visible = true ;
            break ;
        case modeHexView:
            ScrollBox->Visible = false ;
            Caption = "Hex View" ;
            Width = 635 ;
            Height = rect.bottom - Top ;
            if ( (rect.bottom < Height) || (rect.right < Width) )
            {
                // ʂ傫
                if ( rect.bottom < Height )
                {
                    Top  = Screen->DesktopTop ;
                    Height = rect.bottom - Top ;
                }
                if ( rect.right < Width )
                {
                    Left = Screen->DesktopLeft ;
                }
            }
            else
            {
                // ʂ͂ݏoĂȂ璲
                if ( Screen->DesktopTop > Top )
                {   //
                    Top = Screen->DesktopTop ;
                }
                else
                if ( (Screen->DesktopTop + rect.bottom) < (Top + Height) )
                {   //
                    Top = Screen->DesktopTop + (rect.bottom - Height) ;
                }

                if ( Screen->DesktopLeft > Left )
                {   //
                    Left = Screen->DesktopLeft ;
                }
                else
                if ( (Screen->DesktopLeft + rect.right) < (Left + Width) )
                {   //E
                    Left = Screen->DesktopLeft + (rect.right - Width) ;
                }
            }
            binPanel->Visible = true ;
            if ( ! m_binview /* && viewmode == BIN_VIEW*/ )
            {
                binRE->Cursor = crHourGlass ;
                Application->ProcessMessages() ;
                data2bin() ;
                binRE->Cursor = crDefault ;
                m_binview = true ;
            }
            Application->ProcessMessages() ;
            UpdateControlState() ;
            break ;
        default:
            return ;
    }
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::data2bin(void)
{
/** f[^16i\
 */
    TMemoryStream *MS = new TMemoryStream() ;
    if ( (m_hinfo != NULL) && (m_hbm != NULL) )
    {
        dump16( MS, &m_hinfo ) ;
        MS->Write( "\n", 1 ) ;
        dump16( MS, &m_hbm ) ;
        MS->Write( "\0", 1 ) ;
    }
    if ( m_hfile != NULL )
    {
        dump16( MS, &m_hfile ) ;
        MS->Write( "\0", 1 ) ;
    }

    MS->Seek( 0, soFromBeginning ) ;
    binRE->Lines->LoadFromStream( MS ) ;

    delete MS ;
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::dump16(TMemoryStream *MS, HLOCAL *hm)
{
/** f[^16iɕϊ
 */
    const static char hex[16]={'0','1','2','3','4','5','6','7',
                               '8','9','A','B','C','D','E','F'};
    unsigned char buf[16] ;
    unsigned char txtbuf[] = "12345670 : 00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F 0123456789ABCDEF\n" ;
    unsigned char *txt ;
    unsigned int lsize = ::LocalSize( *hm ) ;
    unsigned char *data = (unsigned char *)::LocalLock( *hm ) ;
    unsigned int count = 0 ;
    AnsiString str = "LocalSize = " + (AnsiString)lsize + "\n" ;
    MS->Write( str.c_str(), str.Length() ) ;
    //MS->SetSize( MS->Position + ((lsize +15) >> 4)*76 +1 ) ;
    MS->SetSize( (int)(MS->Position + 0x100*76 +1) ) ;

    for (; count < (lsize >> 4); count++)
    {
        txt = txtbuf;
        // 16oCgo
        for (int i=0; i < 16; i++)
        {
            buf[i] = *(data++) ;
        }
        // AhX
        for (int i=0; i<7; i++)
        {
            *(txt++) = hex[(count >> (4*(6-i))) & 0xf] ;
        }
        txt += 4 ;
        // 16iɕϊ
        for (int i=0; i < 16; i++)
        {
            *(txt++) = hex[buf[i] >> 4] ;
            *(txt++) = hex[buf[i] & 0xf] ;
            txt++ ;
        }
        // ASCII\
        for (int i=0; i < 16; i++)
        {
            if ( isprint(buf[i]) )
            {
                *(txt++) = buf[i] ;
            }
            else
            {
                *(txt++) = '.' ;
            }
        }
        MS->Write( txtbuf, 76 ) ;
        //xȂłꂮ炢Ŋ
        if ( count >= 0xff )
        {
            ::LocalUnlock( *hm ) ;
            return ;
        }
    }

    if ( lsize & 0x0f )
    {
        txt = txtbuf ;
        for (unsigned int i=0; i < (lsize & 0x0f); i++)
        {
            buf[i] = *(data++) ;
        }
        for (int i=0; i<7; i++)
        {
            *(txt++) = hex[(count >> (4*(6-i))) & 0xf] ;
        }
        txt += 4 ;
        unsigned int n=0 ;
        for (; n < (lsize & 0x0f); n++)
        {
            *(txt++) = hex[buf[n] >> 4] ;
            *(txt++) = hex[buf[n] & 0xf] ;
            txt++ ;
        }
        for (unsigned int i=n; i < 16; i++)
        {
            *(txt++) = ' ' ;
            *(txt++) = ' ' ;
            txt++ ;
        }
        for (unsigned int i=0; i < n; i++)
        {
            if ( isprint(buf[i]) )
            {
                *(txt++) = buf[i] ;
            }
            else
            {
                *(txt++) = '.' ;
            }
        }
        for (unsigned int i=n; i < 16; i++)
        {
            *(txt++) = ' ' ;
        }
        MS->Write( txtbuf, 76 ) ;
    }

    ::LocalUnlock( *hm ) ;
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::N1Click(TObject *Sender)
{
    // 摜
    viewchange( modePictureView ) ;
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::N2Click(TObject *Sender)
{
    // 16if[^
    viewchange( modeHexView ) ;
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::ImageMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
/** 摜EBhE傫ꍇɁA}EXhbOł肮蓮
 */
    m_mousedown = true ;
    m_posX = X ;
    m_posY = Y ;
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::ImageMouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
    m_mousedown = false ;
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::ImageMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
    if ( m_mousedown )
    {
        ScrollBox->HorzScrollBar->Position = ScrollBox->HorzScrollBar->Position + (m_posX - X) ;
        ScrollBox->VertScrollBar->Position = ScrollBox->VertScrollBar->Position + (m_posY - Y) ;
        Update() ;
    }
}
//---------------------------------------------------------------------------

